' $INCLUDE: 'JDRBBS.INC'
'
' Copyright (c) 1991-1994, John David Rohner.  All rights reserved.
'
'Various integrity and debugging routines:
'  IntegrityTester1
'  IntegrityTester2
'  IntegrityTester3
'  ListArrays




        '* * * * * *
        ' This routine checks out the USERS file and other user files
        ' for problems.
        '
        ' p  0 if called as an event
        '    1 if called from a menu
        '
        ' Not tested: .PswdChange, .UserNote, .SysopNote, and attribute
        '             or date fields.
        '
        ' Date last checked for perfection: Dec 17 1992
        '
SUB IntegrityTester1 (p)

  CALL BlockToO(3,13)
  TT = 20023
  CALL SendTT
  TT$ = IntToDate3$(SumLog.DateOn) + o$(26)
  CALL ScreamErrorTT
  '
  ' Test that the size of USERS is correct.
  '
  K = FileOpenR(FileNames(1))
  K& = FileLof&(K,1)
  CALL ShowMeter(- K&)
  K0& = 384& * (K& \ 384)
  IF K0& <> K& _
     THEN TT$ = o$(27) + C1310$ + o$(48) + Commas$(K&) + o$(28) + _
                Commas$(K0&) + o$(40) + C1310$ + o$(29) : _
          CALL ScreamErrorTT : _
          TT$ = o$(30) + C1310$ + o$(48) + Commas$(K&) + o$(28) + _
                Commas$(K0&) + o$(32) : _
          CALL SendTT
  '
  ' Test each active user's record.
  '
  K0& = -384
  FOR K2 = 1 TO K& \ 384
    K0& = K0& + 384
    CALL FileGetLoc(K,K0&,384,AnyUser)
    SELECT CASE BitTest(AnyUser.Attr,1)
      CASE 0
           K3 = 0
           K4 = 0
           TT$ = Short$(414)
           K$ = o$(33) + Form4$(6,K2) + o$(34) + AnyUser.UserName + o$(35)
           K0$ = Form4$(6,K2) + AnyUser.UserName
           K1$ = Null$
           FOR K5 = 1 TO 22
             K6 = 0
             SELECT CASE K5
               CASE 1 : IF ASC(AnyUser.UserName) = 32 THEN K6 = -1 : _
                                                           K4 = -1
               CASE 2
                    FOR K7 = 1 TO 30
                      SELECT CASE AscMid(AnyUser.UserName,K7)
                        CASE 0 TO 31, 33, 36, 37, 40 TO 43, 48 TO 64, 91 TO 255
                             K6 = -1
                             K4 = -1
                             EXIT FOR
                      END SELECT
                    NEXT
               CASE 3
                    FOR K7 = 1 TO 15
                      SELECT CASE AscMid(AnyUser.Password,K7)
                        CASE 0 TO 31, 97 TO 122, 128 TO 255
                             K6 = -1
                             EXIT FOR
                      END SELECT
                    NEXT
               CASE 4
                    FOR K7 = 1 TO 30
                      SELECT CASE AscMid(AnyUser.CityState,K7)
                        CASE 0 TO 31, 33, 35 TO 37, 41 TO 43, 60 TO 64, 91 TO 255
                             K6 = -1
                             EXIT FOR
                      END SELECT
                    NEXT
               CASE 5  : K6 = (AnyUser.HiFilePtr   < 0)
               CASE 6  : K6 = (AnyUser.HighestPtr  < 0)
               CASE 7  : K6 = (AnyUser.PagedSysop  < 0)
               CASE 8  : K6 = (AnyUser.Logons      < 0)
               CASE 9  : K6 = (AnyUser.MsgsPosted  < 0)
               CASE 10 : K6 = (AnyUser.EMsgsPosted < 0)
               CASE 11 : K6 = (AnyUser.FMsgsPosted < 0)
               CASE 12 : K6 = (AnyUser.NetMailSent < 0)
               CASE 13 : K6 = (AnyUser.NetMailRcvd < 0)
               CASE 14 : K6 = (AnyUser.Elapsed     < 0)
               CASE 15 : K6 = (AnyUser.Dnlds       < 0)
               CASE 16 : K6 = (AnyUser.DLBytes     < 0)
               CASE 17 : K6 = (AnyUser.MinsDLing   < 0)
               CASE 18 : K6 = (AnyUser.BadDLs      < 0)
               CASE 19 : K6 = (AnyUser.Uplds       < 0)
               CASE 20 : K6 = (AnyUser.MinsULing   < 0)
               CASE 21 : K6 = (AnyUser.BadULs      < 0)
               CASE 22 : K6 = (AnyUser.Doors       < 0)
             END SELECT
             IF K6 THEN K3 = -1 : _
                        TT$ = TT$ + K$ + o$(K5) + C1310$ : _
                        K1$ = K1$ + K0$ + o$(K5)
           NEXT
           IF K3 THEN CALL SendTT : _
                      CALL ScreamError(K1$) : _
                      IF TGot > 0 THEN EXIT FOR
           IF K4 AND p = 1 _
              THEN TT$ = o$(36) : _
                   IF GetYNTT _
                      THEN CALL BitSet(AnyUser.Attr,1) : _
                           CALL FileCloseR(K) : _
                           K = FileOpenW(FileNames(1)) : _
                           K8 = FileOpenW(FileNames(56)) : _
                           CALL FilePutLoc(K,K0&,384,AnyUser) : _
                           CALL CutOut(K8,Null$,BiSearch(2,K8,AnyUser.UserName) * 32& - 31,32&) : _
                           CALL FileCloseW(K8) : _
                           CALL FileCloseW(K) : _
                           K = FileOpenR(FileNames(1))
    END SELECT
    CALL ShowMeter(K0&)
    IF TGot > 0 THEN EXIT FOR
  NEXT
  CALL FileCloseR(K)
  TT = 20037
  CALL SendTT
  '
  ' Test that the size of USERS.IDX is correct.
  '
  K8 = FindF(FileNames(56),FFile)
  K& = FFile.FSize
  K0& = 32& * (K& \ 32)
  IF K0& <> K& _
     THEN TT$ = o$(38) + C1310$ + o$(48) + Commas$(K&) + o$(28) + _
                Commas$(K0&) + o$(40) + C1310$ + o$(41) : _
          CALL ScreamErrorTT : _
          TT$ = o$(39) + C1310$ + o$(48) + Commas$(K&) + o$(28) + _
                Commas$(K0&) + o$(42) : _
          CALL SendTT
  '
  ' Test that the size of USERMSGS is correct.
  '
  K = FileOpenW(FileNames(3))
  K& = FileLof&(K,1)
  K0& = LEN(UserMsgInfo$)
  K0& = K0& * (K& \ K0&)
  IF K0& <> K& _
     THEN TT$ = o$(43) + C1310$ + o$(48) + Commas$(K&) + o$(28) + _
                Commas$(K0&) + o$(40) + C1310$ + o$(45) : _
          CALL ScreamErrorTT : _
          TT$ = o$(44) + C1310$ + o$(48) + Commas$(K&) + o$(28) + _
                Commas$(K0&) + o$(46) : _
          CALL SendTT
  IF K0& < K& THEN DO : CALL FilePutSEnd(K,C0$) : _
                   LOOP UNTIL FileLof&(K,1) = K0&
  IF K0& > K& THEN DO : CALL FilePutLoc(K,FileLof&(K,1) - 1,0,K0) : _
                   LOOP UNTIL FileLof&(K,1) = K0&
  CALL FileCloseW(K)
  '
  ' Test that the size of PEERREVI is correct.
  '
  K = FileOpenW(FileNames(5))
  K& = FileLof&(K,1)
  K0& = 99& * (K& \ 99)
  IF K0& <> K& _
     THEN TT$ = o$(47) + C1310$ + o$(48) + Commas$(K&) + o$(28) + _
                Commas$(K0&) + o$(40) + C1310$ + o$(45) : _
          CALL ScreamErrorTT : _
          TT$ = o$(31) + C1310$ + o$(48) + Commas$(K&) + o$(28) + _
                Commas$(K0&) + o$(46) : _
          CALL SendTT
  IF K0& < K& THEN DO : CALL FilePutSEnd(K,C0$) : _
                   LOOP UNTIL FileLof&(K,1) = K0&
  IF K0& > K& THEN DO : CALL FilePutLoc(K,FileLof&(K,1) - 1,0,K0) : _
                   LOOP UNTIL FileLof&(K,1) = K0&
  CALL FileCloseW(K)
  IF p = 1 THEN CALL Paused

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine checks out the FILELIST file and other files files
        ' for problems.
        '
        ' p  number of directories.
        '
        ' Not tested: .FName, .FDesc, .Percentage, and attribute
        '             or date fields.
        '
        ' Date last checked for perfection: Dec 18 1992
        '
SUB IntegrityTester2 (p)

  CALL BlockToO(3,15)
  TT = 20012
  CALL SendTT
  TT$ = IntToDate3$(SumLog.DateOn) + o$(15)
  CALL ScreamErrorTT
  '
  ' Test that the size of FILELIST is correct.
  '
  K = FileOpenR(FileNames(4))
  K& = FileLof&(K,1)
  CALL ShowMeter(- K&)
  K0& = 119& * (K& \ 119)
  IF K0& <> K& _
     THEN TT$ = o$(16) + C1310$ + o$(29) + Commas$(K&) + o$(17) + _
                Commas$(K0&) + o$(25) + C1310$ + o$(18) : _
          CALL ScreamErrorTT : _
          TT$ = o$(19) + C1310$ + o$(29) + Commas$(K&) + o$(17) + _
                Commas$(K0&) + o$(20) : _
          CALL SendTT
  '
  ' Test each active file's record.
  '
  K0& = -119
  FOR K2 = 1 TO K& \ 119
    K0& = K0& + 119
    CALL FileGetLoc(K,K0&,119,FileList)
    SELECT CASE BitTest(FileList.Attr,1)
      CASE 0
           K3 = 0
           TT$ = Short$(414)
           K$ = o$(21) + Form4$(6,K2) + o$(22) + FileList.FName + o$(23)
           K0$ = Form4$(6,K2) + FileList.FName
           K1$ = Null$
           IF LEN(RTRIM$(FileList.UserName)) = 0 _
              THEN FileList.UserName = Settings.Sysop : _
                   CALL FileCloseR(K) : _
                   K = FileOpenW(FileNames(4)) : _
                   CALL FilePutLoc(K,K0&,119,FileList) : _
                   CALL FileCloseW(K) : _
                   K = FileOpenR(FileNames(4))
           FOR K5 = 1 TO 10
             K6 = 0
             SELECT CASE K5
               CASE 1 : IF ASC(FileList.UserName) = 32 THEN K6 = -1
               CASE 2
                    FOR K7 = 1 TO 30
                      SELECT CASE AscMid(FileList.UserName,K7)
                        CASE 0 TO 31, 33, 36, 37, 40 TO 43, 48 TO 64, 91 TO 255
                             K6 = -1
                             EXIT FOR
                      END SELECT
                    NEXT
               CASE 3  : K6 = (FileList.FArea     > p)
               CASE 4  : K6 = (FileList.FArea     < 0)
               CASE 5  : K6 = (FileList.HiFilePtr < 0)
                         IF FileList.FArea > 0 AND FileList.FArea <= p _
                            THEN IF FileList.HiFilePtr > FileAreaI(FileList.FArea).HiFilePtr _
                                    THEN  K6 = -1
               CASE 6  : K6 = (FileList.LDCount    < 0)
               CASE 7  : K6 = (FileList.FSize      < 0)
               CASE 8  : K6 = (FileList.Password   < 0)
               CASE 9  : K6 = (FileList.Downloaded < 0)
               CASE 10 : IF FileList.Group < 0 OR FileList.Group > 999 _
                            THEN K6 = -1
             END SELECT
             IF K6 THEN K3 = -1 : _
                        TT$ = TT$ + K$ + o$(K5) + C1310$ : _
                        K1$ = K1$ + K0$ + o$(K5)
           NEXT
           IF K3 THEN CALL SendTT : _
                      CALL ScreamError(K1$) : _
                      IF TGot > 0 THEN EXIT FOR
    END SELECT
    CALL ShowMeter(K0&)
    IF TGot > 0 THEN EXIT FOR
  NEXT
  CALL FileCloseR(K)
  TT = 20024
  CALL SendTT
  '
  ' Test that the size of FILES.IDX is correct.
  '
  KK = FindF(FileNames(59),FFile)
  K& = FFile.FSize
  K0& = 22& * (K& \ 22)
  IF K0& <> K& _
     THEN TT$ = o$(26) + C1310$ + o$(29) + Commas$(K&) + o$(17) + _
                Commas$(K0&) + o$(25) + C1310$ + o$(11) : _
          CALL ScreamErrorTT : _
          TT$ = o$(27) + C1310$ + o$(29) + Commas$(K&) + o$(17) + _
                Commas$(K0&) + o$(28) : _
          CALL SendTT
  CALL Delay
  CALL Delay

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine checks out the MESSAGES.HDR file for problems.
        '
        ' Not tested: .NumberReplies and attribute, time, or date fields,
        '             or net address fields.
        '
        ' Date last checked for perfection: Jan 7 1993
        '
SUB IntegrityTester3

  CALL BlockToO(3,16)
  TT = 20013
  CALL SendTT
  TT$ = IntToDate3$(SumLog.DateOn) + o$(17)
  CALL ScreamErrorTT
  '
  ' Test that the size of MESSAGES.HDR is correct.
  '
  K = FileOpenR(FileNames(2))
  K& = FileLof&(K,1)
  CALL ShowMeter(- K&)
  K0& = 136& * (K& \ 136)
  IF K0& <> K& _
     THEN TT$ = o$(18) + C1310$ + o$(29) + Commas$(K&) + o$(19) + _
                Commas$(K0&) + o$(21) + C1310$ + o$(20) : _
          CALL ScreamErrorTT : _
          TT$ = o$(22) + C1310$ + o$(29) + Commas$(K&) + o$(19) + _
                Commas$(K0&) + o$(23) : _
          CALL SendTT
  K1 = FindF(FileNames(73),FFile)
  K1& = FFile.FSize
  '
  ' Test each active file's record.
  '
  K0& = -136
  FOR K2 = 1 TO K& \ 136
    K0& = K0& + 136
    CALL FileGetLoc(K,K0&,136,Message)
    SELECT CASE BitTest(Message.Attr,1)
      CASE 0
           K3 = 0
           TT$ = Short$(414)
           K$ = o$(24) + Form4$(6,K2) + o$(25) + _
                Form$(1002,STR$(Message.MsgNum)) + o$(26) + _
                Form4$(3,Message.MsgBase) + o$(27)
           K0$ = Form4$(6,K2) + Form$(1066,STR$(Message.MsgNum)) + _
                 Form4$(3,Message.MsgBase) + C32$
           K1$ = Null$
           FOR K5 = 1 TO 12
             K6 = 0
             SELECT CASE K5
               CASE 1 : IF ASC(Message.MsgFrom) = 32 THEN K6 = -1
               CASE 2
                    FOR K7 = 1 TO 30
                      SELECT CASE AscMid(Message.MsgFrom,K7)
                        CASE 0, 3 TO 31, 33, 36, 37, 40 TO 43, 48 TO 64, 91 TO 255
                             K6 = -1
                             EXIT FOR
                      END SELECT
                    NEXT
               CASE 3 : IF ASC(Message.MsgTo) = 32 THEN K6 = -1
               CASE 4
                    FOR K7 = 1 TO 30
                      SELECT CASE AscMid(Message.MsgTo,K7)
                        CASE 0, 3 TO 31, 33, 36, 37, 40 TO 43, 48 TO 64, 91 TO 255
                             K6 = -1
                             EXIT FOR
                      END SELECT
                    NEXT
               CASE 5  : K6 = (Message.MsgNum     < 0)
               CASE 6  : K6 = (Message.NumOfBytes < 0)
               CASE 7  : K6 = (Message.NumOfBytes > 8192)
               CASE 8  : K6 = (Message.TimesRead  < 0)
               CASE 9  : K6 = (Message.MsgBase    < 0)
               CASE 10 : K6 = (Message.MsgBase    > BasesSize)
               CASE 11 : K6 = (Message.MsgLoc     < 0)
               CASE 12 : K6 = (Message.MsgLoc     > K1&)
             END SELECT
             IF K6 THEN K3 = -1 : _
                        TT$ = TT$ + K$ + o$(K5) + C1310$ : _
                        K1$ = K1$ + K0$ + o$(K5)
           NEXT
           IF K3 THEN CALL SendTT : _
                      CALL ScreamError(K1$) : _
                      IF TGot > 0 THEN EXIT FOR
    END SELECT
    CALL ShowMeter(K0&)
    IF TGot > 0 THEN EXIT FOR
  NEXT
  CALL FileCloseR(K)
  IF TGot < 1 THEN TT = 20028 : _
                   CALL SendTT

END SUB
        '
        '* * * *




        '* * * * * *
        ' This routine will list the contents of USERS.IDX file and
        ' Files.IDX.  Or rather user names, user record numbers,
        ' file names, and file sizes.
        '
        ' This is mainly a debugging routine to confirm that the
        ' indexes are being maintained properly.
        '
        ' Date last checked for perfection: Sep 14 1992
        '
SUB ListArrays

  TT = 10780
  CALL SendTT
  K8 = FileOpenR(FileNames(56))
  kz = FileLof&(K8,32)
  KK = FileOpenR(FileNames(59))
  kz2 = FileLof&(KK,22)
  IF kz2 > kz THEN K = kz2 _
              ELSE K = kz
  FOR K = 1 TO K
    IF K <= kz _
       THEN CALL FileGetRec(K8,K,32,UserIDX) : _
            TT$ = Form4$(6,UserIDX.RecNum) + Short$(66) + UserIDX.UserName _
       ELSE TT$ = Short$(319)
    IF K <= kz2 THEN CALL FileGetRec(KK,K,22,FileIDX) : _
                     TT$ = TT$ + Short$(367) + Form2$(11,FileIDX.FSize) + _
                           C32$ + Short$(66) + FileIDX.FName
    TT$ = Short$(393) + TT$ + C1310$
    CALL SendTT
    IF TGot > 0 THEN EXIT FOR
  NEXT
  CALL FileCloseR(K8)
  CALL FileCloseR(KK)
  CALL Paused

END SUB
        '
        '* * * *

